/// class PD.Manage.Modules.SyncGroupCommand

PD.Manage.Modules.SyncGroupCommand =
PD.Commands.Command.extend({

    //===================================
    // PUBLIC METHODS
    //===================================

    setDefaults: function () {
        this.props("id", "sync/group");
        this.props("enabled", true);
        this.props("icon", PD.Path.to16x16("arrow_circle2.png"));
        this.props("label", "Sync Group");
        this.props("tooltip", "Update the selected Group with data<br/>retrieved from Active Directory.");
        this.state("groups", null);
    },

    setState: function (state) {
        this._super(state);
        this.props("enabled", this._isEnabled());
    },

    execute: function (e) {
        this._super(e);

        var group = _.first(this.state("groups"));

        this._showSyncDialog(group.id);

    },

    //===================================
    // PRIVATE METHODS
    //===================================

    _isEnabled: function () {
        return _.isArray(this.state("groups"))
            && this.state("groups") != null;
    },

    _showSyncDialog: function (id) {

        PD.Shared.Dialogs.TaskStatus.open({
            config: {
                title: "Sync Group"
            },
            showDetail: true,
            taskStart: function (args) {

                PD.ajax({
                    type: "POST",
                    url: PD.Path.resolve("~/Manage/ActiveDirectory/SyncGroup/" + id),
                    success: function (e) {
                        args.startPolling(e);
                    },
                    error: function (e) {
                        args.abort(e.responseJSON);
                        e.errorHandled = true;
                    }
                });

            },
            close: function (e) {

                PD.context
                    .get_default()
                    .get_events()
                    .publish("sync/refresh");

            }
        });

    }

});